Skip to content
v2.273.0

OpenIdConnectProvider L2 construct ​

IAM OIDC identity providers are entities in IAM that describe an external identity provider (IdP) service that supports the OpenID Connect (OIDC) standard, such as Google or Salesforce.

You use an IAM OIDC identity provider when you want to establish trust between an OIDC-compatible IdP and your AWS account.

This implementation has default values for thumbprints and clientIds props that will be compatible with the eks cluster

Example ​

ts
import * as cdk from 'aws-cdk-lib';
// Step 1: Add retain policy to existing provider
const existingProvider = new eks.OpenIdConnectProvider(this, 'Provider', {
  url: 'https://oidc.eks.us-west-2.amazonaws.com/id/EXAMPLE',
  removalPolicy: cdk.RemovalPolicy.RETAIN, // Add this line
});
python
import aws_cdk as cdk

# Step 1: Add retain policy to existing provider
existing_provider = eks.OpenIdConnectProvider(self, "Provider",
    url="https://oidc.eks.us-west-2.amazonaws.com/id/EXAMPLE",
    removal_policy=cdk.RemovalPolicy.RETAIN
)
java
import software.amazon.awscdk.*;

// Step 1: Add retain policy to existing provider
OpenIdConnectProvider existingProvider = OpenIdConnectProvider.Builder.create(this, "Provider")
        .url("https://oidc.eks.us-west-2.amazonaws.com/id/EXAMPLE")
        .removalPolicy(RemovalPolicy.RETAIN)
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
using Amazon.CDK;

// Step 1: Add retain policy to existing provider
var existingProvider = new OpenIdConnectProvider(this, "Provider", new OpenIdConnectProviderProps {
    Url = "https://oidc.eks.us-west-2.amazonaws.com/id/EXAMPLE",
    RemovalPolicy = RemovalPolicy.RETAIN
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
import cdk "github.com/aws/aws-cdk-go/awscdk"

// Step 1: Add retain policy to existing provider
existingProvider := eks.NewOpenIdConnectProvider(this, jsii.String("Provider"), &OpenIdConnectProviderProps{
	Url: jsii.String("https://oidc.eks.us-west-2.amazonaws.com/id/EXAMPLE"),
	RemovalPolicy: cdk.RemovalPolicy_RETAIN,
})

Initializer ​

ts
new OpenIdConnectProvider(scope: Construct, id: string, props: OpenIdConnectProviderProps)
python
OpenIdConnectProvider(scope: Construct, id: str, props: OpenIdConnectProviderProps)
java
new OpenIdConnectProvider(Construct scope, String id, OpenIdConnectProviderProps props)
csharp
new OpenIdConnectProvider(Construct scope, string id, OpenIdConnectProviderProps props)
go
NewOpenIdConnectProvider(Scope Construct, Id *string, Props OpenIdConnectProviderProps)

Construct Props ​

removalPolicyRemovalPolicyremoval_policyRemovalPolicyremovalPolicyRemovalPolicyRemovalPolicyRemovalPolicyRemovalPolicyRemovalPolicy= RemovalPolicy.DESTROY#
The removal policy to apply to the OpenID Connect Provider.
urlstringurlstrurlStringUrlstringUrl*stringrequired#
The URL of the identity provider.
notes

The URL must begin with https:// and should correspond to the iss claim in the provider's OpenID Connect ID tokens. Per the OIDC standard, path components are allowed but query parameters are not. Typically the URL consists of only a hostname, like https://server.example.org or https://example.com.

You can find your OIDC Issuer URL by: aws eks describe-cluster --name %cluster_name% --query "cluster.identity.oidc.issuer" --output text

Properties ​

The environment this resource belongs to.
notes

For resources that are created and managed in a Stack (those created by creating new class instances like new Role(), new Bucket(), etc.), this is always the same as the environment of the stack they belong to.

For referenced resources (those obtained from referencing methods like Role.fromRoleArn(), Bucket.fromBucketName(), etc.), they might be different than the stack they were imported into.

nodeNodenodeNodenodeNodeNodeNodeNodeNoderequired#
The tree node.
oidcProviderRefOIDCProviderReferenceoidc_provider_refOIDCProviderReferenceoidcProviderRefOIDCProviderReferenceOidcProviderRefOIDCProviderReferenceOidcProviderRefOIDCProviderReferencerequired#
A reference to a OIDCProvider resource.
openIdConnectProviderArnstringopen_id_connect_provider_arnstropenIdConnectProviderArnStringOpenIdConnectProviderArnstringOpenIdConnectProviderArn*stringrequired#
The Amazon Resource Name (ARN) of the IAM OpenID Connect provider.
openIdConnectProviderIssuerstringopen_id_connect_provider_issuerstropenIdConnectProviderIssuerStringOpenIdConnectProviderIssuerstringOpenIdConnectProviderIssuer*stringrequired#
The issuer for OIDC Provider.
openIdConnectProviderthumbprintsstringopen_id_connect_providerthumbprintsstropenIdConnectProviderthumbprintsStringOpenIdConnectProviderthumbprintsstringOpenIdConnectProviderthumbprints*stringrequired#
The thumbprints configured for this provider.
PROPERTY_INJECTION_IDstringproperty_injection_idstrPROPERTY_INJECTION_IDStringPROPERTY_INJECTION_IDstringPROPERTY_INJECTION_ID*stringrequiredstatic#
Uniquely identifies this class.
stackStackstackStackstackStackStackStackStackStackrequired#
The stack in which this resource is defined.

Methods ​

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Override the cross-stack reference strength for this resource.
notes · 1 parameter

When set, any cross-stack reference to this resource will use the specified mechanism instead of the global default determined by the @aws-cdk/core:defaultCrossStackReferences context key. This is useful for selectively weakening specific references to avoid the "deadly embrace" problem without changing the app-wide default.

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy: RemovalPolicy): voiddef apply_removal_policy(self, policy: RemovalPolicy) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy)public void ApplyRemovalPolicy(RemovalPolicy policy)func ApplyRemovalPolicy(Policy RemovalPolicy)#
Apply the given removal policy to this resource.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN).

fromOpenIdConnectProviderArn(scope: Construct, id: string, openIdConnectProviderArn: string): IOpenIdConnectProvider@staticmethod def from_open_id_connect_provider_arn(scope: Construct, id: str, open_id_connect_provider_arn: str) -> IOpenIdConnectProviderpublic static IOpenIdConnectProvider fromOpenIdConnectProviderArn(Construct scope, String id, String openIdConnectProviderArn)public static IOpenIdConnectProvider FromOpenIdConnectProviderArn(Construct scope, string id, string openIdConnectProviderArn)func FromOpenIdConnectProviderArn(Scope Construct, Id *string, OpenIdConnectProviderArn *string) IOpenIdConnectProviderstatic#
Imports an Open ID connect provider from an ARN.
3 parameters

Parameters

  • scopescopescopescopeScope — The definition scope.
  • ididididId — ID of the construct.
  • openIdConnectProviderArnopen_id_connect_provider_arnopenIdConnectProviderArnopenIdConnectProviderArnOpenIdConnectProviderArn — the ARN to import.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

isOwnedResource(construct: IConstruct): boolean@staticmethod def is_owned_resource(construct: IConstruct) -> boolpublic static Boolean isOwnedResource(IConstruct construct)public static bool IsOwnedResource(IConstruct construct)func IsOwnedResource(Construct IConstruct) *boolstatic#
Returns true if the construct was created by CDK, and false otherwise.
isResource(construct: IConstruct): boolean@staticmethod def is_resource(construct: IConstruct) -> boolpublic static Boolean isResource(IConstruct construct)public static bool IsResource(IConstruct construct)func IsResource(Construct IConstruct) *boolstatic#
Check whether the given construct is a Resource.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.